/**
 * @file  cui.cpp
 * @brief ICJ[hƋؓǂݎNXcuiTv
 *
 * Copyright(c) 2011 sharkpp<webmaster@sharkpp.net> All rights reserved.
 * 
 * The MIT License
 * 
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 * 
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 * 
 * ȉɎQlƂ The MIT License ̓{𕹋L܂AЕzƂẮA
 * Lɏ]ĂB
 * 
 * The MIT License
 * 
 * ȉɒ߂ɏ]A{\tgEFAъ֘Ãt@C
 * iȉu\tgEFAvj̕擾邷ׂĂ̐lɑ΂A\tgEFA
 * ɈƂ𖳏ŋ܂Bɂ́A\tgEFA̕gpA
 * ʁAύXAAfځAЕzATuCZXA/܂͔̔錠A
 * у\tgEFA񋟂鑊ɓƂ錠Ɋ܂܂
 * ܂B
 * 
 * L̒쌠\і{\A\tgEFÂׂĂ̕܂͏dv
 * ȕɋLڂ̂Ƃ܂B
 * 
 * \tgEFÁû܂܁vŁAł邩Öقł邩킸A
 * ۏ؂Ȃ񋟂܂Błۏ؂Ƃ́AiA̖ړIւ̓KA
 * ьNQɂĂ̕ۏ؂܂݂܂AɌ肳̂ł͂
 * ܂B҂܂͒쌠҂́A_sׁAs@sׁA܂͂ȊOł낤
 * ƁA\tgEFAɋN܂͊֘AA邢̓\tgEFA̎gp܂͂
 * ̈ɂĐ؂̐AQȂ̋`ɂĉ̐ӔC
 * Ȃ̂Ƃ܂B 
 */

#include "stdafx.h"
#include <windows.h>
#include <libicdlc/icdl.hpp>

#define ICDL_DATE_VAL(v)	\
	ERA_TEXT[v.era_id - ERA_ID_UNKNOWN],	\
	v.year,					\
	v.month,				\
	v.day

#define DATE_FMT "%s%02dN%02d%02d"

struct connect_first_reader {
	icdl & reader;
	connect_first_reader & operator = (connect_first_reader & );
	connect_first_reader(icdl & reader_) : reader(reader_) {}
	bool operator()(LPCTSTR reader_name) {
		return !reader.connect(reader_name);
	}
} ;

int _tmain(int argc, TCHAR* argv[])
{
	TCHAR* ERA_TEXT[] = {
			_T("s"), _T(""), _T("吳"), _T("a"), _T(""), _T("RFU"), _T("RFU"), _T("RFU")
		};
	icdl reader;

	unsigned short pin1 = (unsigned short)(1 < argc ? strtol(argv[1], 0, 10) : 0);
	unsigned short pin2 = (unsigned short)(2 < argc ? strtol(argv[2], 0, 10) : 0);

	if( !scard::enumeration(connect_first_reader(reader), true) )
	{
		printf(_T("ڑɎs"));
		return -1;
	}

	if( !reader.pin_auth(pin1, pin2) )
	{
		printf(_T("Ïؔԍ̔F؂Ɏs܂\nÏؔԍmFĂ\nc:PIN1=%d,PIN2=%d\n")
			, reader.get_pin1_auth_rest()
			, reader.get_pin2_auth_rest());
		return -1;
	}

	printf(_T("%-24s: \"%s\"\n"),		_T(""),						reader.get_name());
	printf(_T("%-24s: \"%s\"\n"),		_T("Ăі(Ji)"),				reader.get_phonetic_name());
	printf(_T("%-24s: \"%s\"\n"),		_T("ʏ̖"),					reader.get_alias_name());
	printf(_T("%-24s: \"%s\"\n"),		_T("ꎁ(Ji)"),			reader.get_unified_name());
	printf(_T("%-24s: " DATE_FMT "\n"),	_T("N"),					ICDL_DATE_VAL(reader.get_birthday()));
	printf(_T("%-24s: \"%s\"\n"),		_T("Z"),						reader.get_domicile());
	printf(_T("%-24s: " DATE_FMT "\n"),	_T("tN"),				ICDL_DATE_VAL(reader.get_issue_date()));
	printf(_T("%-24s: %u\n"),			_T("Ɖԍ"),					reader.get_reference_number());
	printf(_T("%-24s: \"%s\"\n"),		_T("Ƌ؂̐F敪"),			reader.get_license_color());
	printf(_T("%-24s: " DATE_FMT "\n"),	_T("LԂ̖"),			ICDL_DATE_VAL(reader.get_expiration_date()));
	printf(_T("%-24s: \n\"%s\"\n"),		_T("Ƌ̏"),				reader.get_license_requirement());
	printf(_T("%-24s: \"%s\"\n"),		_T("ψ"),				reader.get_police_authority_name());
	printf(_T("%-24s: %12llu\n"),		_T("Ƌ؂̔ԍ"),				reader.get_license_number());
	printf(_T("%-24s: " DATE_FMT "\n"),	_T("Ƌ̔N(EE)"),	ICDL_DATE_VAL(reader.get_license_date_motorcycle_or_small_or_moped()));
	printf(_T("%-24s: " DATE_FMT "\n"),	_T("Ƌ̔N()"),			ICDL_DATE_VAL(reader.get_license_date_misc()));
	printf(_T("%-24s: " DATE_FMT "\n"),	_T("Ƌ̔N()"),		ICDL_DATE_VAL(reader.get_license_date_class_2()));
	printf(_T("%-24s: " DATE_FMT "\n"),	_T("Ƌ̔N(^)"),		ICDL_DATE_VAL(reader.get_license_date_large_sized_motor_vehicle()));
	printf(_T("%-24s: " DATE_FMT "\n"),	_T("Ƌ̔N()"),		ICDL_DATE_VAL(reader.get_license_date_motor_vehicle()));
	printf(_T("%-24s: " DATE_FMT "\n"),	_T("Ƌ̔N()"),		ICDL_DATE_VAL(reader.get_license_date_large_sized_special_motor_vehicle()));
	printf(_T("%-24s: " DATE_FMT "\n"),	_T("Ƌ̔N(厩)"),		ICDL_DATE_VAL(reader.get_license_date_large_sized_motorcycle()));
	printf(_T("%-24s: " DATE_FMT "\n"),	_T("Ƌ̔N()"),		ICDL_DATE_VAL(reader.get_license_date_motorcycle()));
	printf(_T("%-24s: " DATE_FMT "\n"),	_T("Ƌ̔N()"),		ICDL_DATE_VAL(reader.get_license_date_small_sized_special_motor_vehicle()));
	printf(_T("%-24s: " DATE_FMT "\n"),	_T("Ƌ̔N(t)"),		ICDL_DATE_VAL(reader.get_license_date_moped()));
	printf(_T("%-24s: " DATE_FMT "\n"),	_T("Ƌ̔N()"),		ICDL_DATE_VAL(reader.get_license_date_towing()));
	printf(_T("%-24s: " DATE_FMT "\n"),	_T("Ƌ̔N()"),		ICDL_DATE_VAL(reader.get_license_date_class_2_large_sized_motor_vehicle()));
	printf(_T("%-24s: " DATE_FMT "\n"),	_T("Ƌ̔N()"),		ICDL_DATE_VAL(reader.get_license_date_class_2_motor_vehicle()));
	printf(_T("%-24s: " DATE_FMT "\n"),	_T("Ƌ̔N()"),		ICDL_DATE_VAL(reader.get_license_date_class_2_large_sized_special_motor_vehicle()));
	printf(_T("%-24s: " DATE_FMT "\n"),	_T("Ƌ̔N()"),		ICDL_DATE_VAL(reader.get_license_date_class_2_towing()));
	printf(_T("%-24s: " DATE_FMT "\n"),	_T("Ƌ̔N(^)"),		ICDL_DATE_VAL(reader.get_license_date_midsize_motor_vehicle()));
	printf(_T("%-24s: " DATE_FMT "\n"),	_T("Ƌ̔N()"),		ICDL_DATE_VAL(reader.get_license_date_class_2_midsize_motor_vehicle()));
	printf(_T("%-24s: \"%s\"\n"),		_T("{"),						reader.get_registered_domicile());

	printf(_T("%-24s: %s\n"),			_T("ǋL"),						reader.is_append_presents() ? _T("") : _T("Ȃ"));
	if( reader.is_append_presents() ) 
	{
		for(uint16_t i = 0; reader.get_append_domicile_police_authority_name_raw(i); i++) {
			printf(_T("%-24s: %02d " DATE_FMT " \"%s\"\n"),	_T("Znψ")
				, reader.get_append_domicile_police_authority_name_jisx(i)
				, ICDL_DATE_VAL(reader.get_append_domicile_police_authority_name_date(i))
				, reader.get_append_domicile_police_authority_name(i));
		}
		for(uint16_t i = 0; reader.get_append_new_name_raw(i); i++) {
			printf(_T("%-24s: %02d " DATE_FMT " \"%s\" \"%s\"\n"),	_T("V")
				, reader.get_append_new_name_jisx(i)
				, ICDL_DATE_VAL(reader.get_append_new_name_date(i))
				, reader.get_append_new_name(i)
				, reader.get_append_new_name_police_authority_name(i));
		}
		for(uint16_t i = 0; reader.get_append_new_phonetic_name_raw(i); i++) {
			printf(_T("%-24s: %02d " DATE_FMT " \"%s\" \"%s\"\n"),	_T("VĂі")
				, reader.get_append_new_phonetic_name_jisx(i)
				, ICDL_DATE_VAL(reader.get_append_new_phonetic_name_date(i))
				, reader.get_append_new_phonetic_name(i)
				, reader.get_append_new_phonetic_name_police_authority_name(i));
		}
		for(uint16_t i = 0; reader.get_append_new_name_raw(i); i++) {
			printf(_T("%-24s: %02d " DATE_FMT " \"%s\" \"%s\"\n"),	_T("V")
				, reader.get_append_new_name_jisx(i)
				, ICDL_DATE_VAL(reader.get_append_new_name_date(i))
				, reader.get_append_new_name(i)
				, reader.get_append_new_name_police_authority_name(i));
		}
		for(uint16_t i = 0; reader.get_append_new_domicile_raw(i); i++) {
			printf(_T("%-24s: %02d " DATE_FMT " \"%s\" \"%s\"\n"),	_T("VZ")
				, reader.get_append_new_domicile_jisx(i)
				, ICDL_DATE_VAL(reader.get_append_new_domicile_date(i))
				, reader.get_append_new_domicile(i)
				, reader.get_append_new_domicile_police_authority_name(i));
		}
		for(uint16_t i = 0; reader.get_append_new_license_requirement_raw(i); i++) {
			printf(_T("%-24s: %02d " DATE_FMT " \"%s\" \"%s\"\n"),	_T("V")
				, reader.get_append_new_license_requirement_jisx(i)
				, ICDL_DATE_VAL(reader.get_append_new_license_requirement_date(i))
				, reader.get_append_new_license_requirement(i)
				, reader.get_append_new_license_requirement_police_authority_name(i));
		}
		for(uint16_t i = 0; reader.get_append_condition_release_raw(i); i++) {
			printf(_T("%-24s: %02d " DATE_FMT " \"%s\" \"%s\"\n"),	_T("")
				, reader.get_append_condition_release_jisx(i)
				, ICDL_DATE_VAL(reader.get_append_condition_release_date(i))
				, reader.get_append_condition_release(i)
				, reader.get_append_condition_release_police_authority_name(i));
		}
		for(uint16_t i = 0; reader.get_append_remark_raw(i); i++) {
			printf(_T("%-24s: %02d " DATE_FMT " \"%s\" \"%s\"\n"),	_T("l")
				, reader.get_append_remark_jisx(i)
				, ICDL_DATE_VAL(reader.get_append_remark_date(i))
				, reader.get_append_remark(i)
				, reader.get_append_remark_police_authority_name(i));
		}
		for(uint16_t i = 0; reader.get_append_spare_raw(i); i++) {
			printf(_T("%-24s: %02d " DATE_FMT " \"%s\" \"%s\"\n"),	_T("\")
				, reader.get_append_spare_jisx(i)
				, ICDL_DATE_VAL(reader.get_append_spare_date(i))
				, reader.get_append_spare(i)
				, reader.get_append_spare_police_authority_name(i));
		}
	}

	printf(_T("%-24s: %s\n"),			_T("{ВǋL"),					reader.is_append_registered_domicile_presents() ? _T("") : _T("Ȃ"));
	if( reader.is_append_registered_domicile_presents() ) 
	{
		for(uint16_t i = 0; reader.get_append_registered_domicile_raw(i); i++) {
			printf(_T("%-24s: %02d " DATE_FMT " \"%s\" \"%s\"\n"),	_T("{ВǋL")
				, reader.get_append_registered_domicile_jisx(i)
				, ICDL_DATE_VAL(reader.get_append_registered_domicile_date(i))
				, reader.get_append_registered_domicile(i)
				, reader.get_append_registered_domicile_police_authority_name(i));
		}
	}

	printf(_T("%-24s: \n"),				_T("dq"));
	for(const unsigned char * ptr = reader.get_check_code(),
	                        * top = reader.get_check_code(),
	                        * last= reader.get_check_code() + reader.get_check_code_length();
	    ptr < last; )
	{
		printf(_T("  %04X : "), int(ptr - top));
		for(int i = 0; i < 16; i++, ++ptr) {
			if( ptr < last ) {
				printf(_T("%02X "), *ptr);
			} else {
				printf(_T("-- "));
			}
		}
		printf(_T("\n"));
	}

	printf(_T("%-24s: \"%s\"\n"),		_T("VAԍ"),				reader.get_serial_number());
	printf(_T("%-24s: \"%s\"\n"),		_T("sҖ"),					reader.get_publisher_name());
	printf(_T("%-24s: \"%s\"\n"),		_T("̎Җ"),					reader.get_principal_name());

	printf(_T("%-24s: \n"),				_T("̎Ҍʎq"));
	for(const unsigned char * ptr = reader.get_principal_key_id(),
	                        * top = reader.get_principal_key_id(),
	                        * last= reader.get_principal_key_id() + reader.get_principal_key_id_length();
	    ptr < last; )
	{
		printf(_T("  %04X : "), int(ptr - top));
		for(int i = 0; i < 16; i++, ++ptr) {
			if( ptr < last ) {
				printf(_T("%02X "), *ptr);
			} else {
				printf(_T("-- "));
			}
		}
		printf(_T("\n"));
	}

	return 0;
}

