/**
 * @file  scard.hpp
 * @brief X}[gJ[hNX 錾E
 *
 * Copyright(c) 2011 sharkpp<webmaster@sharkpp.net> All rights reserved.
 * 
 * The MIT License
 * 
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 * 
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 * 
 * ȉɎQlƂ The MIT License ̓{𕹋L܂AЕzƂẮA
 * Lɏ]ĂB
 * 
 * The MIT License
 * 
 * ȉɒ߂ɏ]A{\tgEFAъ֘Ãt@C
 * iȉu\tgEFAvj̕擾邷ׂĂ̐lɑ΂A\tgEFA
 * ɈƂ𖳏ŋ܂Bɂ́A\tgEFA̕gpA
 * ʁAύXAAfځAЕzATuCZXA/܂͔̔錠A
 * у\tgEFA񋟂鑊ɓƂ錠Ɋ܂܂
 * ܂B
 * 
 * L̒쌠\і{\A\tgEFÂׂĂ̕܂͏dv
 * ȕɋLڂ̂Ƃ܂B
 * 
 * \tgEFÁû܂܁vŁAł邩Öقł邩킸A
 * ۏ؂Ȃ񋟂܂Błۏ؂Ƃ́AiA̖ړIւ̓KA
 * ьNQɂĂ̕ۏ؂܂݂܂AɌ肳̂ł͂
 * ܂B҂܂͒쌠҂́A_sׁAs@sׁA܂͂ȊOł낤
 * ƁA\tgEFAɋN܂͊֘AA邢̓\tgEFA̎gp܂͂
 * ̈ɂĐ؂̐AQȂ̋`ɂĉ̐ӔC
 * Ȃ̂Ƃ܂B 
 */

#include <windows.h>
#include <winscard.h>

#if defined(_MSC_VER)
#pragma comment(lib, "winscard.lib")
#endif

#if defined(_MSC_VER) && 1000 < _MSC_VER
#pragma once
#endif

#ifndef SCARD_9660DA69_9652_40AF_BDB7_8E630C4F5C77_INCLUDE_GUARD
#define SCARD_9660DA69_9652_40AF_BDB7_8E630C4F5C77_INCLUDE_GUARD

/**
 * @class scard
 * @brief X}[gJ[hNX
 */
class scard
{
	typedef TCHAR          char_type;
	typedef unsigned char  uint8_t;
	typedef unsigned short uint16_t;

	SCARDHANDLE		m_handle;
	SCARDCONTEXT	m_context;
	LONG			m_last_error;

public:

	/// RXgN^
	scard();

	/// fXgN^
	~scard();

	/**
	 * @brief X}[gJ[h֐ڑ
	 * @param[in] reader_name J[h[_[
	 * @retval    true        
	 * @retval    false       sAget_last_error()Ŏs擾ł܂B
	 * @note J[h[_[̂́Ascard::enumeration()ŗ񋓂̂gpĂB
	 */
	bool connect(const char_type * reader_name);

	/**
	 * @brief X}[gJ[hؒf
	 * @retval true  
	 * @retval false sAget_last_error()Ŏs擾ł܂B
	 */
	bool disconnect();

	/**
	 * @brief X}[gJ[hɐڑĂ邩ۂ
	 * @retval true  X}[gJ[h[_[֐ڑς
	 * @retval false X}[gJ[h[_[֐ڑĂȂ
	 */
	bool connected() const;

	/**
	 * @brief X}[gJ[hփf[^𑗐M
	 * @tparam    T      ߂l̎擾\bȟ^
	 * @param[in] cb     ߂l̎擾\bh
	 * @param[in] data   Msf[^
	 * @param[in] length Msf[^
	 * @retval    true   
	 * @retval    false  sAget_last_error()Ŏs擾ł܂B
	 * @note ̃\bh̎sɐĂMĂƂ͌ȂB
	 *       cb͎QƓnł͂ȂlnȂ̂ŒӁI
	 */
	template<typename T>
	bool transmit(T cb, const uint8_t* data, size_t length);

	/**
	 * @brief ŌɎs̃G[l擾
	 * @return G[l
	 * @note ʏ́ASCARD_Ŏn܂萔l
	 */
	LONG get_last_error() const;

	/**
	 * @brief X}[gJ[h[_[
	 * @tparam    T          J[h[_[̎擾\bȟ^
	 * @param[in] cb         J[h[_[̎擾\bh
	 * @param[in] check_card J[h̑}`FbN邩H
	 * @param[in] result     ߂l
	 * @retval    true       
	 * @retval    false      s
	 */
	template<typename T>
	static bool enumeration(T cb, bool check_card = false, LONG * result = NULL);

	/**
	 * @brief X}[gJ[h̖߂l(SW1SW2)擾
	 * @param[in] data   ߂lf[^
	 * @param[in] length ߂lf[^
	 * @return           SW1SW2
	 */
	static uint16_t read_status_byte(const void * data, size_t length);
};

inline
scard::scard()
	: m_handle(NULL)
	, m_context(NULL)
	, m_last_error(0)
{
}

inline
scard::~scard()
{
	disconnect();
}

inline
bool scard::connect(const char_type * reader_name)
{
	DWORD protocol = 0;

	disconnect();

	if( !reader_name || !*reader_name ) {
		m_last_error = SCARD_E_INVALID_PARAMETER;
		return false;
	}


	m_last_error = ::SCardEstablishContext(SCARD_SCOPE_USER, NULL, NULL, &m_context);
	if( SCARD_S_SUCCESS != m_last_error ) {
		return false;
	}


	m_last_error = ::SCardConnect(m_context, reader_name, SCARD_SHARE_SHARED,
	                              SCARD_PROTOCOL_T0|SCARD_PROTOCOL_T1, &m_handle, &protocol);
	if( SCARD_S_SUCCESS != m_last_error ) {
		::SCardReleaseContext(m_context);
		m_handle  = NULL;
		m_context = NULL;
		return false;
	}

	return true;
}

inline
bool scard::disconnect()
{
	if( m_handle ) {
		m_last_error = ::SCardDisconnect(m_handle, SCARD_LEAVE_CARD);
		m_handle = NULL;
	}

	if( m_context ) {
		m_last_error = SCardReleaseContext(m_context);
		m_context = NULL;
	}

	return m_last_error != SCARD_S_SUCCESS;
}

inline
bool scard::connected() const
{
	return NULL != m_handle;
}

template<typename T>
inline bool scard::transmit(T cb, const uint8_t* data, size_t length)
{
	uint8_t res[2048];
	DWORD   cch = sizeof(res);

	if( !connected() ) {
		m_last_error = SCARD_E_INVALID_HANDLE;
		return false;
	}

	m_last_error = ::SCardTransmit(m_handle, SCARD_PCI_T1, data,
	                               length, NULL, res, &cch);
	if( SCARD_S_SUCCESS == m_last_error )
	{
		cb(res, cch);
	}

	return SCARD_S_SUCCESS == m_last_error;
}

inline
LONG scard::get_last_error() const
{
	return m_last_error;
}

template<typename T>
inline static bool scard::enumeration(T cb, bool check_card, LONG * result)
{
	LONG         lr;
	SCARDCONTEXT context;
	LPTSTR       readers, reader;
	DWORD        cch = SCARD_AUTOALLOCATE;
	DWORD        protocol = 0;
	SCARDHANDLE  handle = NULL;

	if( !result ) {
		result = &lr;
	}


	*result = ::SCardEstablishContext(SCARD_SCOPE_USER, NULL, NULL, &context);
	if( SCARD_S_SUCCESS == *result )
	{

		*result = ::SCardListReaders(context, NULL, (LPTSTR)&readers, &cch);
		if( SCARD_S_SUCCESS == *result )
		{
			for(reader = readers; *reader; reader += _tcslen(reader) + 1 )
			{
				if( !check_card )
				{

					cb(reader);
				}
				else
				{

					*result = ::SCardConnect(context, readers, SCARD_SHARE_SHARED,
					                         SCARD_PROTOCOL_T0|SCARD_PROTOCOL_T1, &handle, &protocol);
					if( SCARD_S_SUCCESS == *result ) {
						::SCardDisconnect(handle, SCARD_LEAVE_CARD);

						cb(reader);
					}
				}
			}

			::SCardFreeMemory(context, readers);
		}

		::SCardReleaseContext(context);
	}

	return SCARD_S_SUCCESS == *result;
}

inline
uint16_t scard::read_status_byte(const void * data, size_t length)
{
	const uint8_t * data_ = (const uint8_t*)data;

	if( length < 2 ) {
		return 0xFFFF;
	}

	return (data_[length - 2] << 8) | data_[length - 1];
}


#endif
